	device zxspectrum128
        ORG #6000
begin
uplace equ $A000
tplace equ $5B00
et equ tplace+768
;	call depack
;	call s1
;	call depack
;	call s8
	ld a,7:out ($FE),a
	ld hl,song:call INIT

;	ld hl,$5800,de,$5803,bc,765:set 6,(hl):ldir
    ld hl,$5AFF,de,$5AFe,bc,$1B00-1,(hl),0:lddr
	ld ix,ti1:call prt
	
	ld a,$44,(tc+1),a
	call prt
	ld hl,0,($5955),hl

	call prt
	call prt
wak:
	ld a,$f7:in a,($FE):rra:jr nc,key1
	ld a,$7F:in a,($FE):rra:jr nc,gos
	jr wak
key1:
	ld a,(prt):xor $C9:ld (prt),a
	ld hl,$5953,b,3
	ei:halt:halt:halt
kx: ld a,(hl)
	xor $44
	ld (hl),a
	inc l
	djnz kx
wk1: ld a,$f7:in a,($FE):rra:jr nc,wk1
	jp wak
gos:
	ld a,r,(sh1+1),a
;set int
	di
	ld hl,$BE00,de,$BE01,bc,257,(hl),$BF:ldir
	ld a,$C3,($BFBF),a
	ld hl,intvec,($BFBF+1),hl
	ld a,$BE,i,a
	im 2
	ei
gl:
	call depack
	call showp
	call pictitle
	ld bc,50*60
mu: ei:halt
vk: ld a,$7F:in a,($FE)
	rra: jr nc,exk
	dec bc
	ld a,b:or c
	jr nz,mu
exk:
	jp gl

intvec:
	push ix,iy
	push hl,de,bc,af
	exx:exa
	push hl,de,bc,af
	CALL PLAY
	pop af,bc,de,hl
	exx:exa
	pop af,bc,de,hl
	pop iy,ix
	ei:ret

showp:
sh1: ld a,0
	inc a
	ld (sh1+1),a
	and 7
	ld l,a,h,0,de,jst
	add hl,hl
	add hl,de
	ld a,(hl):inc hl
	ld h,(hl),l,a
	jp (hl)
	jr $
pictitle:
ptp: ld hl,0
	ld de,mest
	add hl,hl
	add hl,de
	ld a,(hl):inc hl
	ld h,(hl),l,a
	push hl
	pop ix

;draw debug
;	ld hl,$5820,b,16
;ddl:
;	ld (hl),1*9:inc l
;	ld (hl),6*9:inc l
;	djnz ddl

	jp prt
mest:
 dw m0,m1,m2,m3,m4,m5,m6,m7,m8,m9
 dw m10,m11,m12,m13,m14,m15,m16,m17,m18

jst:
	dw s1,s2,s3,s4,s5,s6,s7,s8
s8:
	ld hl,t8
	ld a,32
	jp s11
s7:
	ld hl,t7
	ld a,32
	jp s11

s6:
	ld hl,t6
	ld a,23
	jp s11

s5:
	ld hl,t5
	ld a,0
	jp s11

s4:
	ld hl,t4
	ld a,22
	jp s11
s2:
	ld hl,t2
	ld a,27
	jp s11
s3:
	ld hl,t3
	ld a,64
	jp s11
s1:
	ld hl,t1
	ld a,28
s11:
	ld (ce+1),a
	call u7
	ld iyl,0
sl0:
	ld b,0
	ld ix,tplace
sl1y:
	ld c,0
sl2x:
	ld a,(ix+0)
	cp iyl
	jp nz,s1n
	call ch8
;	jr $
s1n:
	inc ix
	inc c
	bit 5,c
	jp z,sl2x
	inc b
	ld a,b
	cp 24
	jp nz,sl1y
;	jr $
	inc iyl
	ld a,iyl
ce:	cp 28
	jp nz,sl0
;	ld hl,uplace,de,#4000,bc,6144:ldir
	ret

ch8:
	ld l,b
	add hl,hl
	add hl,hl
	ld h,11
	add hl,hl
	add hl,hl
	add hl,hl
	ld a,l
	or c
	ld l,a
	ld e,a
	ld a,h
	add (uplace+6144)/256 - $58
	ld d,a
	ld a,(de),(hl),a
;chars
		ld	hl, 4000h
		ld	a, b
		and	18h
		or	h
		ld	h, a
		ld	a, b
		and	7
		ld	d, a
		srl	d
		rr	l
		srl	d
		rr	l
		srl	d
		rr	l
		ld e,c
		add	hl, de

	ld e,l
	ld a,h
	add uplace/256 - $40
	ld d,a

 dup 8
 ld a,(de),(hl),a
 inc h,d
edup
	ret

u7:
	ld de,tplace
	jp dzx7_standard
depack:
dv1: ld l,0
	ld h,0
	ld (ptp+1),hl
	ld de,orderp
	add hl,hl
	add hl,hl
	add hl,de
	ld a,(hl):inc hl,hl
	ld bc,$7FFD:out (c),a
	ld a,(hl):inc hl
	ld h,(hl),l,a
	
	ld de,uplace
	call dzx7_standard
	ld a,(dv1+1)
	inc a
	cp 19
	jr nz,nolframe
	xor a
nolframe:
	ld (dv1+1),a
	ret
orderp:
	dw $10,pic0
	dw $10,pic1
	dw $10,pic2
	dw $10,pic3
	dw $10,pic4
	dw $10,pic5
	
	dw $11,pic6
	dw $11,pic7
	dw $11,pic8
	dw $11,pic9
	dw $11,pic10
	dw $11,pic11

	dw $13,pic12
	dw $13,pic13
	dw $13,pic14
	dw $13,pic15

	dw $14,pic16
	dw $14,pic17
	dw $14,pic18

prt: nop

	ld e,(ix+0):inc ix
	ld d,(ix+0):inc ix
	
	push de
	exx
	pop hl
		ld a,h
	and %000111000
	rra
	rra
	rra
	add a,$58
	ld h,a
	exx
plp:
	ld a,(ix+0):inc ix
	or a:ret z
	
	ld l,a,h,0
	ld bc,fnt
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,bc
	
	exx
tc:	ld (hl),$46
	inc l
	exx
	push de
 dup 8
 ld a,(hl),(de),a
 inc hl,d
edup
	pop de
;2
	ld a,(ix+0):inc ix
	or a:ret z
	ld l,a,h,0
	ld bc,fnt
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,bc

	push de
 dup 8
 ld a,(hl)
 or a
 rra:rra:rra:rra
 ld c,a
 ld a,(de)
 or c
 ld (de),a
 inc hl,d
edup
	pop de
	inc e
	jp plp
ti1:
 dw $4807
 db "Liv Tyler portrait compo by @zxgfx"
 db 0
ti2:
 dw $4849
 db "1.Display title/name YesNo"
 db 0
ti3:
 dw $48C9
 db "music:MMCM,code:g0blinish"
 db 0
ti4:
 dw $4887
 db "space to continue(and skip delays)"
 db 0

m0:
	dw $400B
	db "Liv Tyler by Prgmr"
	db 0
m1:
	dw $4009
	db "liv tyler by scalesmann^mc"
	db 0
m2:
	dw $4006
	db "Liv Tyler Classic by 誠 ࠯"
	db 0
m3:
	dw $400B
	db "Liv Tyler by dman"
	db 0
m4:
	dw $400B
	db "ANSI Liv by dman"
	db 0
m5:
	dw $400B
	db "Liv Forever by diver"
	db 0
m6:
	dw $400B
	db "liv ledge by "
	db 0
m7:
	dw $4008
	db " liv stealing beauty by "
	db 0
m8:
	dw $4001
	db "Dad, I don't want to paint this woman anymore by Lerustin"
	db 0
m9:
	dw $400B
	db "(I)ࢥ by Art-top"
	db 0
m10:
	dw $400C
	db "liv1 by nodeus"
	db 0
m11:
	dw $4004
	db "Liv Tyler V2[One Frame] by breeze\fishbone crew"
	db 0
m12:
	dw $4005
	db "Liv Tyler[One Frame] by breeze\fishbone crew"
	db 0
m13:
	dw $400A-2
	db "(II)  by Art-top"
	db 0
m14:
	dw $4002
	db "  । ਢ ᯥ㬨⠬ by Kakos_nonos"
	db 0
m15:
	dw $400B
	db "Liv2 by Surfin' Bird"
	db 0
m16:
	dw $400C
	db "liv2 by nodeus"
	db 0
m17:
	dw $4009
	db "Live!Tailor by Surfin' Bird"
	db 0
m18:
	dw $400B-2
	db "(III)too young by Schafft"
	db 0

fnt:incbin "8x4.bin"

zx7:include "zx7.a80"
song:incbin "MmcM - WaL'sOk (2021) (DiHalt 2021, 1).pt3"
plyr:include "PTxPlay.a80"

t1:incbin "pic1.tab.zx7"
t2:incbin "pic2.tab.zx7"
t3:incbin "pic3.tab.zx7"
t4:incbin "pic4.tab.zx7"
t5:incbin "pic5.tab.zx7"
t6:incbin "pic6.tab.zx7"
t7:incbin "pic7.tab.zx7"
t8:incbin "pic8.tab.zx7"
end

	page 0
 DEFINE pg0
	org $C000
page0b:
pic0:incbin"page0\9458_l_tyler_1_scr.scr.zx7" ;Liv Tyler by Prgmr
pic1:incbin"page0\9460_liv_tyler.scr.zx7" ;liv tyler by scalesmann^mc
pic2:incbin"page0\9461_livtyler.scr.zx7" ;Liv Tyler Classic by 誠 ࠯
pic3:incbin"page0\9463_liv_tyler.scr.zx7" ;Liv Tyler by dman
pic4:incbin"page0\9510_liv.scr.zx7" ;ANSI Liv by dman
pic5:incbin"page0\9532_liv_forever.scr.zx7" ;Liv Forever by diver
page0e:

	page 1
	org $C000
 DEFINE pg1

page1b:
pic6:incbin"page1\9466_liv_ledge.scr.zx7" ;liv ledge by 
pic7:incbin"page1\9468_liv_stealing_beauty.scr.zx7" ;liv stealing beauty by 
pic8:incbin"page1\9477_tetya1_scr.scr.zx7";Dad, I don't want to paint this woman anymore by Lerustin
pic9:incbin"page1\9481_liv_tiler.scr.zx7";ࢥ by Art-top
pic10:incbin"page1\9489_liv1.scr.zx7";liv1 by nodeus
pic11:incbin"page1\9512_livtyler_2_oneframe_.scr.zx7";Liv Tyler V2[One Frame] by breeze\fishbone crew
page1e:

	page 3
	org $C000
 DEFINE pg3

page3b:
pic12:incbin"page3\9506_livtyler_oneframe_.scr.zx7";Liv Tyler[One Frame] by breeze\fishbone crew
pic13:incbin"page3\9522_liv_tyler2.scr.zx7";  by Art-top
pic14:incbin"page3\9524_liv_3.scr.zx7";  । ਢ ᯥ㬨⠬ by Kakos_nonos
pic15:incbin"page3\9526_liv2.scr.zx7";Liv2 by Surfin' Bird
page3e:

	page 4
	org $C000
 DEFINE pg4

page4b:
pic16:incbin"page4\9492_liv2.scr.zx7";liv2 by nodeus
pic17:incbin"page4\9499_live_tailor_bw.scr.zx7";Live!Tailor by Surfin' Bird
pic18:incbin"page4\9502_lt_2021-too young.scr.zx7";	too young by Schafft
page4e:

	display /d,end-begin
	display end
	savesna "!void.sna",begin

;-----------------------------------------------------------
;add after
;page0b:
; DEFINE pg0

 macro	sectors datab,datae

	db 1,5,(datae-datab+255)/256
; IF low (datae-datab)=0
;   db 1,5,high (datae-datab)
; ELSE
;   db 1,5,(1+high (datae-datab))
; ENDIF
;
	endm

 MODULE boot
Basic:
 db #00,#01; ப
 DW EndLine1 - Line1
Line1:
 db #EA;REM

 ;test 128K
	ld hl,$FFFF
	ld bc,$7FFD
	ld de,$1011
	out (c),d:ld (hl),d
	out (c),e:ld (hl),e
	out (c),d
	ld a,(hl):cp d:ret nz

 ld sp,#5FFE

    res 4,(iy+1)
    xor a:out ($FE),a
    ld hl,$5AFF,de,$5AFe,bc,$1B00-1,(hl),0:lddr

;title
;	IFUSED tit_b
; di
; ld de,(#5CF4)
; ld hl, #6000
;; ld a,#10,bc,#7FFD:out (c),a
; sectors tit_b,tit_e
; call #3d13
; call #6000
;	ENDIF

;demo
 di
 ld de,(#5CF4)
 ld hl, #6000
 ld a,#10,bc,#7FFD:out (c),a
 sectors begin,end
 call #3d13

	IFDEF pg0
 di
 ld de,(#5CF4)
 ld hl, #C000
 sectors page0b,page0e
 call #3d13
	ENDIF

	IFDEF pg1
 di
 ld de,(#5CF4)
 ld hl, #C000
 ld a,#11,bc,#7FFD:out (c),a
 sectors page1b,page1e
 call #3d13
	ENDIF

	IFDEF pg3
 di
 ld de,(#5CF4)
 ld hl, #C000
 ld a,#13,bc,#7FFD:out (c),a
 sectors page3b,page3e
 call #3d13
	ENDIF

	IFDEF pg4
 di
 ld de,(#5CF4)
 ld hl, #C000
 ld a,#14,bc,#7FFD:out (c),a
 sectors page4b,page4e
 call #3d13
	ENDIF

 ld a,#10,bc,#7ffd:out (c),a
 jp begin


 db "fuckhype"
 db #0D
EndLine1:
 db #00,#02
 DW EndLine2 - Line2
Line2:
 db #20,#FD,#B0
 db #22,#32,#34,#35,#37,#35,#22;clear val "24575"
 db #3A; :
 db #F9,#C0,#28,#35;randomize usr (5+256*peek val "23635"+peek val "23636"
 db #0E,#00,#00,#05,#00,#00,#2B
 db #32,#35,#36
 db #0E,#00,#00,#00,#01,#00,#2A,#BE

 db #B0
 db #22,#32,#33,#36,#33,#36,#22;"23635"
 db #2B;???
 db #BE
 db #B0
 db #22,#32,#33,#36,#33,#35,#22;"23636"
 db #29

;+128K
	db ":",245 ;:PRINT
	db 34,17,0,16,7,"128K only",34
 
 db #0D;)
 db #80
 db #AA,1,0;;;;;;;;;;;;;autorun line,change program length to -4, e.g. 83-4=79
EndLine2:
EndBasic:
 ENDMODULE

	display /d,end-begin

    EMPTYTRD "dust.trd" ;create empty TRD image
	SAVETRD "dust.trd", "ltss.B", boot.Basic, boot.EndBasic - boot.Basic

;	IFUSED tit_b
;    SAVETRD "dust.trd","pict.C",tit_b,tit_e-tit_b
;	ENDIF

    SAVETRD "dust.trd","demo.C",begin,end-begin

	IFDEF pg0
    PAGE 0
    SAVETRD "dust.trd","pg0.C",page0b,page0e-page0b
	ENDIF

	IFDEF pg1
    PAGE 1
    SAVETRD "dust.trd","pg1.C",page1b,page1e-page1b
	ENDIF

	IFDEF pg3
    PAGE 3
    SAVETRD "dust.trd","pg3.C",page3b,page3e-page3b
	ENDIF

	IFDEF pg4
    PAGE 4
    SAVETRD "dust.trd","pg4.C",page4b,page4e-page4b
	ENDIF

;-----------------------------------------------------------
